'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _toast = require('jw-components-mobile/lib/toast');

var _toast2 = _interopRequireDefault(_toast);

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

require('jw-components-mobile/lib/toast/style');

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _upload = require('../../images/upload.png');

var _upload2 = _interopRequireDefault(_upload);

var _del = require('../../images/del.png');

var _del2 = _interopRequireDefault(_del);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var DrivePicker = function (_Component) {
	_inherits(DrivePicker, _Component);

	function DrivePicker(props) {
		_classCallCheck(this, DrivePicker);

		var _this = _possibleConstructorReturn(this, (DrivePicker.__proto__ || Object.getPrototypeOf(DrivePicker)).call(this, props));

		var schema = _this.props.schema;
		if (schema.defaultValue) {
			schema.value = schema.defaultValue;
		}
		console.log(schema.defaultValue);
		_this.state = {
			schema: schema,
			emsg: "xxxdsadsadas"
		};
		return _this;
	}

	_createClass(DrivePicker, [{
		key: 'onChange',
		value: function onChange(value, schema) {
			console.log(value, schema);
			this.props.onChange(value, schema);
			var propsSchema = this.state.schema;
			if (propsSchema['events'] && propsSchema['events']['onChange']) {
				propsSchema['events']['onChange'].call(this, arguments);
			}
		}
	}, {
		key: 'getLabel',
		value: function getLabel(txt) {
			if (txt) {
				return _react2.default.createElement('div', { className: 'label ant-form-item-label', dangerouslySetInnerHTML: { __html: txt } });
			} else {
				return '';
			}
		}
	}, {
		key: 'onClick',
		value: function onClick() {
			var schema = this.state.schema;
			var self = this;
			var rules = schema.rules;
			var filetypes = [];
			var emsg = "";
			_.map(rules, function (item) {
				if (item.filetypes) {
					filetypes = item.filetypes;
					emsg = item.message;
				}
			});

			jw.choseFile({
				count: 1, // 默认 9 
				sizeType: ['original', 'compressed'],
				sourceType: ['album', 'camera', 'jwfiles'],
				saveToAlbum: 0 // 默认保存到相册，0 不保存 2020 年 6 月 17 日新增 
			}, {
				success: function success(res) {
					var localId = res.localFiles[0].id;
					// alert(JSON.stringify(res.localFiles[0]))
					var type = res.localFiles[0].type.split('/')[1];
					alert(type);
					if (filetypes.length != 0 && filetypes.indexOf(type) == -1) {
						_toast2.default.info(emsg, 2, null, false);
						return;
					}

					jw.privateUploadFile({
						"localId": localId, //本地文件id，str类型，必填，格式必须是h ttps:/jwlocalres/ + id，ps：h ttps加空格为了信息流可见，调用的时候不要加空格
						"appId": schema.appId, // 数据id，str类型，必填
						"appType": schema.appType, // 数据类型，str类型，必填
						"isShowProgressTips": 1, //是否显示进度提示 int类型，非必填，默认为1，ps：只有0和1两个状态，1:显示，0:不显示
						"showSuccessTips": 1 //是否显示上传成功提示 int类型，非必填，默认为1，ps：只有0和1两个状态，1:显示，0:不显示
					}, {
						success: function success(res) {
							var value = !schema.value ? [res.data.attachment] : schema.value.push(res.data.attachment);
							schema.value = value;
							self.setState({
								schema: schema
							});
							self.onChange(value, schema);
						}
					});
				}
			});
		}
	}, {
		key: 'getImage',
		value: function getImage(images) {
			if (images && images[0] && images[0].preview) {
				return _react2.default.createElement(
					'div',
					{ className: 'label-image ant-form-item-image' },
					_react2.default.createElement('img', { src: images[0].preview.open_link })
				);
			} else {
				return '';
			}
		}
	}, {
		key: 'del',
		value: function del(item, index) {
			var schema = this.state.schema;
			var value = [];
			_.map(schema.value, function (i, index1) {
				if (index === index1) {} else {
					value.push(i);
				}
			});
			schema.value = value;
			this.setState({
				schema: schema
			});
			this.onChange(value, schema);
		}
	}, {
		key: 'render',
		value: function render() {
			var schema = this.state.schema;
			!schema.value ? schema.value = [] : "";

			var self = this;
			var rules = schema.rules;
			var count = void 0;
			_.map(rules, function (item) {
				if (item.max) {
					count = item.max;
				}
			});
			var style = void 0;
			if (schema.value.length < count) {
				style = {
					width: 2.4154589372 * (schema.value.length + 1) + 'rem'
				};
			} else {
				style = {
					width: 2.4154589372 * schema.value.length + 'rem'
				};
			}
			return _react2.default.createElement(
				'div',
				{ className: 'Form-item-w', ref: 'container' },
				this.getLabel(schema.label),
				this.getImage(schema.attachments),
				!schema.value || schema.value.length == 0 ? _react2.default.createElement(
					'div',
					{ className: 'drivepicker-upload', onClick: this.onClick.bind(this) },
					_react2.default.createElement('img', { src: _upload2.default })
				) : _react2.default.createElement(
					'div',
					{ className: 'drivepicker-upload-list-c' },
					_react2.default.createElement(
						'div',
						{ className: 'drivepicker-upload-list', style: style },
						schema.value.length < count ? _react2.default.createElement(
							'div',
							{ className: 'drivepicker-upload', onClick: this.onClick.bind(this) },
							_react2.default.createElement('img', { src: _upload2.default })
						) : "",
						_.map(schema.value, function (item, index) {
							return _react2.default.createElement(
								'div',
								{ className: 'files-item' },
								_react2.default.createElement('img', { src: item.thumbnail.url }),
								_react2.default.createElement(
									'div',
									{ className: 'del', onClick: self.del.bind(self, item, index) },
									_react2.default.createElement(
										'div',
										{ className: 'del-bg' },
										'\xA0'
									),
									_react2.default.createElement('img', { src: _del2.default })
								)
							);
						})
					)
				)
			);
		}
	}, {
		key: 'componentDidMount',
		value: function componentDidMount() {
			//初始化

		}
	}, {
		key: 'componentDidUpdate',
		value: function componentDidUpdate() {
			//变化
			// console.log(this.refs.template,'123');
		}
	}]);

	return DrivePicker;
}(_react.Component);

exports.default = DrivePicker;